<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DT_QMIS_Survey StructType
 * @subpackage Structs
 */
class DT_QMIS_Survey extends AbstractStructBase
{
    /**
     * The Records
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Records[]
     */
    public $Records;
    /**
     * Constructor method for DT_QMIS_Survey
     * @uses DT_QMIS_Survey::setRecords()
     * @param \StructType\Records[] $records
     */
    public function __construct(array $records = array())
    {
        $this
            ->setRecords($records);
    }
    /**
     * Get Records value
     * @return \StructType\Records[]|null
     */
    public function getRecords()
    {
        return $this->Records;
    }
    /**
     * This method is responsible for validating the values passed to the setRecords method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecords method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecordsForArrayConstraintsFromSetRecords(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $dT_QMIS_SurveyRecordsItem) {
            // validation for constraint: itemType
            if (!$dT_QMIS_SurveyRecordsItem instanceof \StructType\Records) {
                $invalidValues[] = is_object($dT_QMIS_SurveyRecordsItem) ? get_class($dT_QMIS_SurveyRecordsItem) : sprintf('%s(%s)', gettype($dT_QMIS_SurveyRecordsItem), var_export($dT_QMIS_SurveyRecordsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Records property can only contain items of type \StructType\Records, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Records value
     * @throws \InvalidArgumentException
     * @param \StructType\Records[] $records
     * @return \StructType\DT_QMIS_Survey
     */
    public function setRecords(array $records = array())
    {
        // validation for constraint: array
        if ('' !== ($recordsArrayErrorMessage = self::validateRecordsForArrayConstraintsFromSetRecords($records))) {
            throw new \InvalidArgumentException($recordsArrayErrorMessage, __LINE__);
        }
        $this->Records = $records;
        return $this;
    }
    /**
     * Add item to Records value
     * @throws \InvalidArgumentException
     * @param \StructType\Records $item
     * @return \StructType\DT_QMIS_Survey
     */
    public function addToRecords(\StructType\Records $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Records) {
            throw new \InvalidArgumentException(sprintf('The Records property can only contain items of type \StructType\Records, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Records[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DT_QMIS_Survey
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
